

!========================          FUNCPA_WEIB          ====================
    double precision function funcpasweib_log(b,np,id,thi,jd,thj,k0)
    use tailles
    !use comon,only:etaR,etaD,betaR,betaD
    use comon,only:t0,t1,c,nsujet,nva, &
    nst,stra,ve,effet,ng,g,nig,AG,kkapa,sig2,sig22, &
    indictronq,auxig,res3,res5,res6,sig_prob,sig_prob2,  &
    etaT,betaT,res2_ind,res3_ind,res1,k0T,Kmat1,Kmat2, corrRE, Ut,Ut22,&
	Ut_table,nmemb,currentage,proband,agemin,sig_fixed
    use residusM
	use lois_normales
	use donnees_indiv,only:it_rec
	use optim
    
	implicit none

! *** NOUVELLLE DECLARATION F90 :

    integer::nb,np,id,jd,i,j,k,cptg,ig,choix,ii,jj
    integer,dimension(ngmax)::cpt
    double precision::thi,thj,dnb,res,vet,int,finddet,eps,slogasc
    double precision,dimension(np)::b,bh
    double precision,dimension(ngmax)::res2!res1,
    double precision,dimension(2)::k0
    double precision,dimension(ngmax)::integrale1,integrale2,integrale3,integrale,det_all
    double precision,parameter::pi=3.141592653589793d0

	! for the numerical integral hrmsym
        integer :: restar,nf,ier
        double precision:: epsabs,epsrel
        double precision,dimension(2):: result, abserr2
        double precision,dimension(1000) :: work
        external :: vraistot
        integer ::neval,ifail
		
    kkapa=k0 ! inutile dans le calcul mais est quand meme argument de la fonction donc doit etre present
    j=0


    bh=b

    if (id.ne.0) bh(id)=bh(id)+thi
    if (jd.ne.0) bh(jd)=bh(jd)+thj

    ii=1 !en plus strates A.Lafourcade 05/2014
    do jj=1,nst
        betaT(jj)=bh(ii)**2
        etaT(jj)=bh(ii+1)**2
        ii=ii+2
    end do

    if(effet.eq.1.and.corrRE.le.1) then
        sig2 = bh(np-nva)*bh(np-nva)
	else if(corrRE.eq.2) then
		sig2 = sig_fixed!1.d0!
		sig22 = bh(np-nva)*bh(np-nva)!bh(np-nva-1)*bh(np-nva-1)!1.d0!
    endif

!-------------------------------------------------------
!--------- calcul de la vraisemblance ------------------
!-------------------------------------------------------

!--- avec ou sans variable explicative  ------cc

    res1 = 0.d0
    res2 = 0.d0
    res3 = 0.d0
    res2_ind = 0.d0
	res3_ind = 0.d0
	integrale = 1.d0
	integrale1 = 1.d0
    integrale2 = 1.d0
    integrale3 = 1.d0
    res5 = 0.d0
	res6 = 0.d0
	sig_prob = 0.d0
    cpt = 0

!*******************************************
!---- sans effet aleatoire dans le modele
!*******************************************

    if (effet.eq.0) then
        do i=1,nsujet
            cpt(g(i))=cpt(g(i))+1

            if(nva.gt.0)then
                vet = 0.d0
                do j=1,nva
                    vet =vet + bh(np-nva+j)*dble(ve(i,j))
                end do
                vet = dexp(vet)
            else
                vet=1.d0
            endif

            if(c(i).eq.1)then !en plus strates A.Lafourcade 05/2014
                res2(g(i)) = res2(g(i))+(betaT(stra(i))-1.d0)*dlog(t1(i)-agemin)+ &
                dlog(betaT(stra(i)))-betaT(stra(i))*dlog(etaT(stra(i)))+dlog(vet)
            endif

            if ((res2(g(i)).ne.res2(g(i))).or.(abs(res2(g(i))).ge. 1.d30)) then
                funcpasweib_log=-1.d9
                goto 123
            end if
           !en plus strates A.Lafourcade 05/2014
            res1(g(i)) = res1(g(i)) + (((t1(i)-agemin)/etaT(stra(i)))**betaT(stra(i)))*vet -&
			((t0(i)/etaT(stra(i)))**betaT(stra(i)))*vet
            RisqCumul(i) = (((t1(i)-agemin)/etaT(stra(i)))**betaT(stra(i)))*vet

            if ((res1(g(i)).ne.res1(g(i))).or.(abs(res1(g(i))).ge. 1.d30)) then
                funcpasweib_log=-1.d9
                goto 123
            end if
        end do

        res = 0.d0
        cptg = 0

! k indice les groupes
        do k=1,ng
            if(cpt(k).gt.0)then
                nb = nig(k)
                dnb = dble(nig(k))
                res = res-res1(k)+res2(k)
                cptg = cptg + 1
                if ((res.ne.res).or.(abs(res).ge. 1.d30)) then
                    funcpasweib_log=-1.d9
                    goto 123
                end if
            endif
        end do

!*********************************************
!----avec un effet aleatoire dans le modele
!*********************************************

    else

! i indice les sujets
        do i=1,nsujet

            cpt(g(i))=cpt(g(i))+1

            if(nva.gt.0)then
                vet = 0.d0
                do j=1,nva
                    vet =vet + bh(np-nva+j)*dble(ve(i,j))
                end do
                vet = dexp(vet)
            else
                vet=1.d0
            endif

            if(c(i).eq.1)then !en plus strates A.Lafourcade 05/2014
                res2(g(i)) = res2(g(i))+(betaT(stra(i))-1.d0)*dlog((t1(i)-agemin))+ &
                dlog(betaT(stra(i)))-betaT(stra(i))*dlog(etaT(stra(i)))+dlog(vet)
            endif
!write(*,*)res2(g(i)),betaT(stra(i)),dlog(t1(i)),etaT(stra(i)),dlog(vet)
            if ((res2(g(i)).ne.res2(g(i))).or.(abs(res2(g(i))).ge.1.d30)) then
                 funcpasweib_log=-1.d9
                 goto 123
            end if
!if(res2(1).ge.1.33772.and.res2(1).le.1.33773)write(*,*)i,res2(g(i)),betaT(stra(i)),dlog(t1(i)),etaT(stra(i)),dlog(vet)
 
! modification pour nouvelle vraisemblance / troncature:
            !en plus strates A.Lafourcade 05/2014
            	res3_ind(i) = ((t0(i)/etaT(stra(i)))**betaT(stra(i)))*vet
          res3(g(i)) = res3(g(i)) + ((t0(i)/etaT(stra(i)))**betaT(stra(i)))*vet ! en plus
           res5(i) = (((t1(i)-agemin)/etaT(stra(i)))**betaT(stra(i)))*vet
            res1(g(i)) = res1(g(i)) + res5(i) ! pour les résidus
		
		res6(i) = ((currentage(i)-agemin)/etaT(stra(i)))**betaT(stra(i))*vet !cumulative hazard for probands
			
		
            if ((res3(g(i)).ne.res3(g(i))).or.(abs(res3(g(i))).ge.1.d30)) then
                print*,"here6"
                funcpasweib_log=-1.d9
                goto 123
            end if

            if ((res5(i).ne.res5(i)).or.(abs(res5(i)).ge.1.d30)) then
                print*,"here7",res5(i),i,t1(i),agemin,vet,((t1(i)-agemin)/etaT(stra(i))),&
				(((t1(i)-agemin)/etaT(stra(i)))**betaT(stra(i)))
                funcpasweib_log=-1.d9
                goto 123
            end if
        end do

!**************INTEGRALES ****************************
       if(corrRE.eq.0) then
			do ig=1,ng
				auxig = ig
				choix = 1
				call gauherS(int,choix)
				integrale1(ig) = int
				if (AG.eq.1) then
					choix = 3
					call gauherS(int,choix)
					integrale3(ig) = int
					auxig = ig
				epsabs = 1.d-100
				epsrel = 1.d-100
				restar = 0
				nf = 1
				allocate(Ut(1,1))
				Ut = dsqrt(sig2)
					call  hrmsym(1, nf, 30, 500,vraistot, epsabs, &
                    epsrel, restar, result, abserr2, neval, ifail, work)
		integrale(ig) =result(1)
			deallocate(ut)
				endif
				if (indictronq.eq.1) then
					choix = 2
					call gauherS(int,choix)
					integrale2(ig) = int
				endif
			end do
		else if(corrRE.eq.1) then
			it_rec = 1
			det_all = 0.d0
			do ig = 1,ng
				auxig = ig
				epsabs = 1.d-100
				epsrel = 1.d-100
				restar = 0
				nf = 1
				allocate(Ut(nmemb(ig),nmemb(ig)),Ut_table(nmemb(ig)*(nmemb(ig)+1)/2))
				Ut = 0.d0
				do j=1,nmemb(ig)
					do k=1,nmemb(ig)
						Ut(j,k) =sig2* Kmat1(it_rec+j-1,it_rec+k-1)!sqrt(sig2)* 
					end do
				end do
			
				det_all(ig) = finddet(Ut,nmemb(ig))
					Ut = 0.d0
						do j=1,nmemb(ig)
					do k=1,nmemb(ig)
						Ut(j,k) =sig2* Kmat1(it_rec+j-1,it_rec+k-1)!
						
					 if(j.eq.k)sig_prob(it_rec+j-1) = Ut(j,k)
					end do
				end do
				jj = 0
				do j=1,nmemb(ig)
					do k=j,nmemb(ig)
						jj=j+k*(k-1)/2
						Ut_table(jj)=Ut(j,k)
					end do
				end do
		
				call dmfsdj(Ut_table, nmemb(ig),eps,ier)
				
			
				Ut=0.d0
				do j=1,nmemb(ig)
                  do k=1,j
                     Ut(j,k)=Ut_table(k+j*(j-1)/2)
                  end do
				end do
			   
				call  hrmsym(nmemb(ig), nf, 30, 750,vraistot, epsabs, &
                    epsrel, restar, result, abserr2, neval, ifail, work)
		 
				if (result(1).le.1.d-150) then
					result(1)=1.d-150
				end if
				integrale(ig) =result(1)
			!	write(*,*)ig,integrale(ig)
				it_rec = it_rec + nmemb(ig)
				deallocate(Ut,Ut_table)
			end do
		else if(corrRE.eq.2) then 
		it_rec = 1
			det_all = 0.d0
			do ig = 1,ng
				auxig = ig
				epsabs = 1.d-100
				epsrel = 1.d-100
				restar = 0
				nf = 1
				allocate(Ut(nmemb(ig),nmemb(ig)),Ut22(nmemb(ig),nmemb(ig)),Ut_table(nmemb(ig)*(nmemb(ig)+1)/2))
				Ut = 0.d0
				Ut22 = 0.d0
				do j=1,nmemb(ig)
					do k=1,nmemb(ig)
						Ut(j,k) =sig2*Kmat1(it_rec+j-1,it_rec+k-1)+sig22* Kmat2(it_rec+j-1,it_rec+k-1)
					Ut22(j,k) =sig22* Kmat2(it_rec+j-1,it_rec+k-1)
					if(j.eq.k) then 
					sig_prob(it_rec+j-1) = sig2*Kmat1(it_rec+j-1,it_rec+k-1)
					sig_prob2(it_rec+j-1) = Ut22(j,k)
					end if
				end do
				end do
		
		
				jj = 0
				do j=1,nmemb(ig)
					do k=j,nmemb(ig)
						jj=j+k*(k-1)/2
						Ut_table(jj)=Ut(j,k)
					end do
				end do
		
				call dmfsdj(Ut_table, nmemb(ig),eps,ier)
				
			
				Ut=0.d0
				do j=1,nmemb(ig)
                  do k=1,j
                     Ut(j,k)=Ut_table(k+j*(j-1)/2)
                  end do
				end do
				
				
				jj = 0
				do j=1,nmemb(ig)
					do k=j,nmemb(ig)
						jj=j+k*(k-1)/2
						Ut_table(jj)=Ut22(j,k)
					end do
				end do
		
				call dmfsdj(Ut_table, nmemb(ig),eps,ier)
				
			
				Ut22=0.d0
				do j=1,nmemb(ig)
                  do k=1,j
                     Ut22(j,k)=Ut_table(k+j*(j-1)/2)
                  end do
				end do
			   
				call  hrmsym(nmemb(ig), nf, 30, 750,vraistot, epsabs, &
                    epsrel, restar, result, abserr2, neval, ifail, work)
!	write(*,*)ig,result(1)
				if (result(1).le.1.d-150) then
					result(1)=1.d-150
				end if
				integrale(ig) =result(1)
			!write(*,*)ig,integrale(ig),nmemb(ig)
			it_rec = it_rec + nmemb(ig)
				deallocate(Ut,Ut22,Ut_table)
			end do
		end if
!************* FIN INTEGRALES ************************
!stop
        res = 0.d0
        cptg = 0

!     gam2 = gamma(inv)
! k indice les groupes

        do k=1,ng
                if(corrRE.eq.0) then
!ccccc ancienne vraisemblance : ANDERSEN-GILL ccccccccccccccccccccccccc
                    if(AG.EQ.1)then
                        res = res+res2(k)-dlog(dsqrt(sig2))-dlog(2.d0*pi)/2.d0+ &
                        dlog(integrale3(k))
!ccccc nouvelle vraisemblance :ccccccccccccccccccccccccccccccccccccccccccccccc
                    else
                        res = res+res2(k)+dlog(integrale1(k)) &
                        -dlog(integrale2(k))
                    endif
                 
                else
				res = res+res2(k)-nmemb(k)*dlog(2.d0*pi)/2.d0+&!-0.5d0*dlog(abs(det_all(k)))+&
                        dlog(integrale(k))!+res2(k)
						
				end if
				   if ((res.ne.res).or.(abs(res).ge. 1.d30)) then
                        print*,"here8",k,res,res2(k),integrale(k),corrRE
                          funcpasweib_log=-1.d9
                          goto 123
                    end if
!     developpement de taylor d ordre 3
!                   write(*,*)'************** TAYLOR *************'
!cccc ancienne vraisemblance :ccccccccccccccccccccccccccccccccccccccccccccccc
                    !if(AG.EQ.1)then
                    !    res = res-dnb*dlog(theta*(res1(k)-res3(k))+1.d0) &
                    !    -(res1(k)-res3(k))*(1.d0-theta*(res1(k)-res3(k))/2.d0 &
                    !    +theta*theta*(res1(k)-res3(k))*(res1(k)-res3(k))/3.d0)+res2(k)+sum

!cccc nouvelle vraisemblance :ccccccccccccccccccccccccccccccccccccccccccccccc
                    !else
                    !    res = res-dnb*dlog(theta*res1(k)+1.d0)-res1(k)*(1.d0-theta*res1(k) &
                    !    /2.d0+theta*theta*res1(k)*res1(k)/3.d0) &
                    !    +res2(k)+sum &
                    !    +res3(k)*(1.d0-theta*res3(k)/2.d0 &
                    !        +theta*theta*res3(k)*res3(k)/3.d0)
                    !endif
                       !if ((res.ne.res).or.(abs(res).ge. 1.d30)) then
                        !  funcpasweib_log=-1.d9
                         ! goto 123
                       !end if
                !endif
            !endif
        end do
    endif !fin boucle effet=0
!if(res.ge.0.d0)then 
!write(*,*)res 
!write(*,*)res2 
!write(*,*)integrale 
!write(*,*)-0.5d0*dlog(abs(det_all(k)))-nmemb(k)*dlog(2.d0*pi)/2.d0 
!stop 
!end if

!    Changed JRG 25 May 05
    if ((res.ne.res).or.(abs(res).ge. 1.d30)) then
      funcpasweib_log=-1.d9
      goto 123
    end if
		
	!!!! Ascertainment correction
	slogasc  = 0.d0
	do i = 1,nsujet 
		if(proband(i).eq.1) then 
		
			auxig = i
		
		!	write(*,*)i,-((currentage(i)/etaT(stra(i)))**betaT(stra(i))),vet,exp(-((currentage(i)/etaT(stra(i)))**betaT(stra(i)))*vet),&
		!	1-exp(-((currentage(i)/etaT(stra(i)))**betaT(stra(i)))*vet),dlog(1-exp(-((currentage(i)/etaT(stra(i)))**betaT(stra(i)))*vet))
				if(corrRE.eq.1)then 
					call gauherASC(int,1,sig_prob(i))
				else if(corrRE.eq.2) then 
					call gauherASC2(int,2,sig_prob(i))
				end if
				
		!		write(*,*)auxig,res6(auxig),int,currentage
			if(c(i).eq.1) then 
				slogasc = slogasc + dlog(1-int)
			else 
				slogasc = slogasc + dlog(int)
			end if
		end if 
	end do
	!	write(*,*)res,slogasc
  funcpasweib_log = res - slogasc

	 if ((funcpasweib_log.ne.funcpasweib_log).or.(abs(funcpasweib_log).ge. 1.d30)) then
      funcpasweib_log=-1.d9
      goto 123
    end if
    do k=1,ng
        cumulhaz(k)=res1(k)
    end do

123     continue

    return

    end function funcpasweib_log


!==========================  DISTANCE   =================================
! fonction supprimée car déjà définie dans funcpassplines.f90


  subroutine gausshermiteBIS2017(ss,npg)

        double precision::ss,ss1
       double precision::auxfunca
      double precision,external::func301
        INTEGER::ii,jj,npg
        double precision,dimension(npg)::X,W

	

        x(1)=-6.863345294d0
        x(2)=-6.13827922d0
        x(3)=-5.533147152d0
        x(4)=-4.988918969d0
        x(5)=-4.483055357d0
        x(6)=-4.003908604d0
        x(7)=-3.544443873d0
        x(8)=-3.09997053d0
        x(9)=-2.667132125d0
        x(10)=-2.243391468d0
        x(11)=-1.826741144d0
        x(12)=-1.4155278d0
        x(13)=-1.008338271d0
        x(14)=-0.603921059d0
        x(15)=-0.201128577d0
        x(16)=0.201128577d0
        x(17)=0.603921059d0
        x(18)=1.008338271d0
        x(19)=1.4155278d0
        x(20)=1.826741144d0
        x(21)=2.243391468d0
        x(22)=2.667132125d0
        x(23)=3.09997053d0
        x(24)=3.544443873d0
        x(25)=4.003908604d0
        x(26)=4.483055357d0
        x(27)=4.988918969d0
        x(28)=5.533147152d0
        x(29)=6.13827922d0
        x(30)=6.863345294d0

        w(1)=0.834247471d0
        w(2)=0.649097981d0
        w(3)=0.569402692d0
        w(4)=0.522525689d0
        w(5)=0.491057996d0
        w(6)=0.468374813d0
        w(7)=0.451321036d0
        w(8)=0.438177023d0
        w(9)=0.427918063d0
        w(10)=0.419895004d0
        w(11)=0.413679364d0
        w(12)=0.408981575d0
        w(13)=0.405605123d0
        w(14)=0.403419817d0
        w(15)=0.402346067d0
        w(16)=0.402346067d0
        w(17)=0.403419817d0
        w(18)=0.405605123d0
        w(19)=0.408981575d0
        w(20)=0.413679364d0
        w(21)=0.419895004d0
        w(22)=0.427918063d0
        w(23)=0.438177023d0
        w(24)=0.451321036d0
        w(25)=0.468374813d0
        w(26)=0.491057996d0
        w(27)=0.522525689d0
        w(28)=0.569402692d0
        w(29)=0.649097981d0
        w(30)=0.834247471d0

    
        auxfunca=0.d0
    ss=0.d0
    ss1=0.d0
!      call gaussher(gauss,npg)
    ii=0
!write(*,*)"okkkkk"
!stop

    do ii=1,npg
        jj=0
        do jj=1,npg
            auxfunca=func301(x(ii),x(jj))
            ss1 = ss1+w(jj)*(auxfunca)
        end do
        ss = ss+w(ii)*ss1
!   write(*,*)'',ss!func30(x(ii),x(jj))
!    pause
    end do

    end subroutine gausshermiteBIS2017
	
	
	    double precision  function func301(frail1,frail2)
! calcul de l integrant, pour un effet aleatoire donne frail et un groupe donne auxig (cf funcpa)
 use optim
    use taillesmultiv
    use comonmultiv,only:nigmeta,alpha1,alpha2,res1meta,res3meta,&
    nig,auxig,alpha,theta,eta,aux1,res1,res3,cdc 
	use comon,only:c,res5,res3_ind,ut
    use donnees_indiv,only:it_rec 
    implicit none

    double precision::frail1,frail2
            double precision :: yscalar,eps,finddet,det,res22,alnorm,prod_cag
            integer :: j,i,jj,k,ier,ii
            double precision,dimension(2*(2+1)/2)::matv
            double precision,dimension(2,1)::  Xea2
            double precision,dimension(2):: uii, Xea22,Xea
            double precision,dimension(1)::uiiui
            double precision,dimension(2,2)::mat
	double precision,dimension(2,2)::Utt
            double precision,parameter::pi=3.141592653589793d0

	

	Xea(1) = frail1 
	Xea(2) = frail2 
	
	        Xea2(1:2,1) = Xea(1:2)
    
            Xea22(1:2) = Xea(1:2)
    Utt = 0.d0
    
    do j=1,2
		do k=1,2
            Utt(j,k)=Ut(k,j)
        end do
    end do
            mat = matmul(ut,utt)
    
            jj=0
    do j=1,2
        do k=j,2
        jj=j+k*(k-1)/2
        matv(jj)=mat(j,k)
            end do
            end do
            ier = 0
            eps = 1.d-10
    
            call dsinvj(matv,2,eps,ier)
    
            mat=0.d0
        do j=1,2
                    do k=1,2
                                        if (k.ge.j) then
                mat(j,k)=matv(j+k*(k-1)/2)
                else
                mat(j,k)=matv(k+j*(j-1)/2)
                end if
            end do
                        end do
    
                    uii = matmul(Xea22,mat)
                    det = finddet(matmul(ut,utt),2)
    
    
                    uiiui=matmul(uii,Xea2)
    
    
    func301=0.d0
 !   func30 = frail1*(cdc(auxig)*alpha1+nig(auxig)) &
 !   +frail2*(cdc(auxig)*alpha2+nigmeta(auxig)) &
 !   -dexp(frail1)*(res1(auxig)-res3(auxig))-dexp(frail2)*(res1meta(auxig)-res3meta(auxig)) &
 !   -dexp(frail1*alpha1+frail2*alpha2)*aux1(auxig) &
 !   +(2.d0*((2.d0*dexp(alpha)/(dexp(alpha)+1.d0))-1.d0) &
 !   *frail1*frail2/sqrt(theta*eta)  &
 !   -(frail1**2.d0)/theta -(frail2**2.d0)/eta) &
 !   /(2.d0*(1.d0-((2.d0*dexp(alpha)/(dexp(alpha)+1.d0))-1.d0)**2.d0))
 !   func30 = dexp(func30)
 
 do j=1,2
		
	func301 = func301+dlog(dexp((xea(j))*c(it_rec+j-1)-dexp(xea(j))*(res5(it_rec+j-1)-&
			res3_ind(it_rec+j-1))))-uiiui(1)/2.d0-0.5d0*dlog(det)&
                       -dlog(2.d0*pi)!&

!	vrais= dexp(ui(1)*nig(auxig) &
  !  -dexp(ui(1))*(res1(auxig)-res3(auxig)))
	

		end do
		
 func301 = dexp(func301)
    return

    end function func301
